<?php 
/*
V2.40 4 Sept 2002  (c) 2000-2002 John Lim (jlim@natsoft.com.my). All rights reserved.
  Released under both BSD license and Lesser GPL library license. 
  Whenever there is any discrepancy between the two licenses, 
  the BSD license will take precedence.
  
  Some pretty-printing by Chris Oxenreider <oxenreid@state.net>
*/ 
  
// specific code for tohtml
GLOBAL $gSQLMaxRows,$gSQLBlockRows;
	 
$gSQLMaxRows = 1000; // max no of rows to download
$gSQLBlockRows=20; // max no of rows per table block

// RecordSet to HTML Table
//------------------------------------------------------------
// Convert a recordset to a html table. Multiple tables are generated
// if the number of rows is > $gSQLBlockRows. This is because
// web browsers normally require the whole table to be downloaded
// before it can be rendered, so we break the output into several
// smaller faster rendering tables.
//
// $rs: the recordset
// $ztabhtml: the table tag attributes (optional)
// $zheaderarray: contains the replacement strings for the headers (optional)
//
//  USAGE:
//	include('adodb.inc.php');
//	$db = ADONewConnection('mysql');
//	$db->Connect('mysql','userid','password','database');
//	$rs = $db->Execute('select col1,col2,col3 from table');
//	rs2html($rs, 'BORDER=2', array('Title1', 'Title2', 'Title3'));
//	$rs->Close();
//
// RETURNS: number of rows displayed
function rs2html(
				&$rs,
				$viewMode = 'Grid',
				$ztabhtml=false,
				$zheaderarray=false,
				$htmlspecialchars=true, 
				$fieldsProperties='', 
				$fieldKey='',
				$fieldsExtra='',
				$fieldDelete_flag = false,
				$fieldDelete_Asc = 'Are you sure?'
				)
{

$s ='';$rows=0;$docnt = false;
GLOBAL $gSQLMaxRows,$gSQLBlockRows;

	if (!$rs) {
		printf(ADODB_BAD_RS,'rs2html');
		return false;
	}
	
	if (! $ztabhtml) $ztabhtml = "BORDER='1' WIDTH='98%'";
	//else $docnt = true;
	$typearr = array();
	$ncols = $rs->FieldCount();
//	echo "ncols : $ncols<hr>";
	$hdr = "<TABLE COLS=$ncols $ztabhtml>\n\n";
	
	//-- JavaScript   
	
	if( $fieldDelete_flag AND $fieldsExtra ){
		$hdr .= '
			<script language="JavaScript">
				function ask_before_delete($url) {
					if (window.confirm("'.$fieldDelete_Asc.'")) {
						window.parent.location=$url;
					};
				};
			</script>';
	}

	if( $viewMode=='Record' ){


		//--  
		
		for ($i=0; $i < $ncols; $i++) {	
			$field = $rs->FetchField($i);
			if( $fieldsProperties[$field->name]!='hidden' ){
				if( $fieldsProperties[$field->name] ){
					if( preg_match("/link:/", $fieldsProperties[$field->name] ) ){
//						$records_link[$i] = strstr($fieldsProperties[$field->name], 'link:');
						$records_link[$i] = str_replace('link:', '', $fieldsProperties[$field->name]);
					}
					elseif( $fieldsProperties[$field->name]=='www' ){
						$records_link[$i] = 'www';
					}
					elseif( $fieldsProperties[$field->name]=='e-mail' ){
						$records_link[$i] = 'e-mail';
					}
//					echo $records_link[$i];
				}
/*
				if ($zheaderarray) $fname = $zheaderarray[$i];
				else $fname = htmlspecialchars($field->name);	
				$typearr[$i] = $rs->MetaType($field->type,$field->max_length);
//				print " $field->name $field->type $typearr[$i] ";
				if (strlen($fname)==0) $fname = '&nbsp;';
				$hdr .= "<TH>$fname</TH>";
*/
				$records_hidden[$i] = true;
			}
		}
		
/*
		//--     
		
		if( $fieldsExtra ){
			while( list( $name, $link ) = each( $fieldsExtra ) ){
				$hdr .= "<TH>$name</TH>";
			}
		}
*/

		//--  
		
//		$hdr = str_replace('width="100%"', '', "<TABLE COLS=$ncols $ztabhtml>\n\n");
		print $hdr."\n\n";
//		print "<TABLE width='50%' COLS=$ncols $ztabhtml>\n\n";
		
		// smart algorithm - handles ADODB_FETCH_MODE's correctly!
		$numoffset = isset($rs->fields[0]);
		while (!$rs->EOF) {
//			$s .= "<TR valign=top>\n";
			
			for ($i=0, $v=($numoffset) ? $rs->fields[0] : reset($rs->fields); 
				$i < $ncols; 
				$i++, $v = ($numoffset) ? @$rs->fields[$i] : next($rs->fields)) {
				
				$field = $rs->FetchField($i);
				
				$type = $typearr[$i];		
								
				switch($type) {				
				case 'T': if( preg_match("/dformat:/", $fieldsProperties[$field->name] ))  $dformat = str_replace('dformat:', '', $fieldsProperties[$field->name]); $s .= "	<TD>".$rs->UserTimeStamp($v,$dformat) ."&nbsp;</TD>\n"; break;
				case 'D': $s .= "	<TD>".$rs->UserDate($v,"D d, M Y") ."&nbsp;</TD>\n"; break;
				case 'I':
				case 'N': $s .= "	<TD align=right>".stripslashes((trim($v))) ."&nbsp;</TD>\n"; break;
				default:
					if ($htmlspecialchars) $v = htmlspecialchars($v);
					if( $records_hidden[$i] ){
						$s .= "<TR valign=top>\n";
						$s .= " <TD>".htmlspecialchars($field->name)."&nbsp;</TD>\n";
						if( $records_link[$i]=='www' ){
//							if( preg_match("/http:///", $v ) ){}
							$s .= '	<TD><a target="_blank" href="http://'.$v.'">'.$v."</a>&nbsp;</TD>\n";
						}
						elseif( $records_link[$i]=='e-mail' ){
							$s .= '	<TD><a target="_blank" href="mailto:'.$v.'">'.$v."</a>&nbsp;</TD>\n";
						}
						elseif( $records_link[$i] ){
							$s .= '	<TD><a href="'.str_replace('{$'.$fieldKey.'}', $rs->fields[$fieldKey], $records_link[$i]).'">'. str_replace("\n",'<br>',stripslashes((trim($v)))) ."</a>&nbsp;</TD>\n";
						}
						else{
							$s .= "	<TD>". str_replace("\n",'<br>',stripslashes((trim($v)))) ."&nbsp;</TD>\n";
						}
						$s .= "</TR>\n\n";
					}
				  
				}
			} // for
			
/*
			//--     
			
			if( $fieldsExtra ){
				reset($fieldsExtra);
				while( list( $name, $link ) = each( $fieldsExtra ) ){
					$s .= '	<TD><a href="'.str_replace('{$'.$fieldKey.'}', $rs->fields[$fieldKey], $link).'">'.$name."</a>&nbsp;</TD>\n";
				}
			}
//			$s .= "</TR>\n\n";
			  
			$rows += 1;
			if ($rows >= $gSQLMaxRows) {
				$rows = "<p>Truncated at $gSQLMaxRows</p>";
				break;
			} // switch
*/
			$rs->MoveNext();
		
		// additional EOF check to prevent a widow header
			if (!$rs->EOF && $rows % $gSQLBlockRows == 0) {
		
			//if (connection_aborted()) break;// not needed as PHP aborts script, unlike ASP
				print $s . "</TABLE>\n\n";
				$s = $hdr;
			}
		} // while

		print $s."</TABLE>\n\n";

	}
	else{				
		//--  
		
		for ($i=0; $i < $ncols; $i++) {	
			$field = $rs->FetchField($i);
			if( $fieldsProperties[$field->name]!='hidden' ){
				if( $fieldsProperties[$field->name] ){
					if( preg_match("/link:/", $fieldsProperties[$field->name] ) ){
//						$records_link[$i] = strstr($fieldsProperties[$field->name], 'link:');
						$records_link[$i] = str_replace('link:', '', $fieldsProperties[$field->name]);
					}
					elseif( $fieldsProperties[$field->name]=='www' ){
						$records_link[$i] = 'www';
					}
					elseif( $fieldsProperties[$field->name]=='e-mail' ){
						$records_link[$i] = 'e-mail';
					}
//					echo $records_link[$i];
				}
				if ($zheaderarray) $fname = $zheaderarray[$i];
				else $fname = htmlspecialchars($field->name);	
				$typearr[$i] = $rs->MetaType($field->type,$field->max_length);
//				print " $field->name $field->type $typearr[$i] ";
				if (strlen($fname)==0) $fname = '&nbsp;';
				$hdr .= "<TH align=center>$fname</TH>";
				$records_hidden[$i] = true;
			}
		}
		
		//--     
		
		if( $fieldsExtra ){
			while( list( $name, $link ) = each( $fieldsExtra ) ){
				$hdr .= "<TH align=center>$name</TH>";
			}
		}

		//--  
		
		print $hdr."\n\n";
		
		// smart algorithm - handles ADODB_FETCH_MODE's correctly!
		$numoffset = isset($rs->fields[0]);
		while (!$rs->EOF) {
			$s .= "<TR valign=top>\n";
			
			for ($i=0, $v=($numoffset) ? $rs->fields[0] : reset($rs->fields); 
				$i < $ncols; 
				$i++, $v = ($numoffset) ? @$rs->fields[$i] : next($rs->fields)) {
				
					$field = $rs->FetchField($i);
					
				$type = $typearr[$i];
				switch($type) {
				case 'T': 			
					if( preg_match("/dformat:/", $fieldsProperties[$field->name] ))  
						$dformat = str_replace('dformat:', '', $fieldsProperties[$field->name]);						
					else 				
						$dformat = "D d, M Y, h:i:s";
					$s .= "	<TD align=center>".$rs->UserTimeStamp($v,$dformat) ."&nbsp;</TD>\n";
				break;
				case 'D': 
					if( preg_match("/dformat:/", $fieldsProperties[$field->name] ))  
						$dformat = str_replace('dformat:', '', $fieldsProperties[$field->name]);						
					else 				
						$dformat = "D d, M Y, h:i:s";				
					$s .= "	<TD align=center>".$rs->UserDate($v,$dformat) ."&nbsp;</TD>\n";
				break;
				case 'I':
				case 'N':
					$s .= "	<TD align=right>".stripslashes((trim($v))) ."&nbsp;</TD>\n";
				   	
				break;
				default:
					if ($htmlspecialchars) $v = htmlspecialchars($v);
					if( $records_hidden[$i] ){
						if( $records_link[$i]=='www' ){
//							if( preg_match("/http:///", $v ) ){}
							$s .= '	<TD align=center><a target="_blank" href="http://'.$v.'">'.$v."</a>&nbsp;</TD>\n";
						}
						elseif( $records_link[$i]=='e-mail' ){
							$s .= '	<TD align=center><a target="_blank" href="mailto:'.$v.'">'.$v."</a>&nbsp;</TD>\n";
						}
						elseif( $records_link[$i] ){
							$s .= '	<TD align=center><a href="'.str_replace('{$'.$fieldKey.'}', $rs->fields[$fieldKey], $records_link[$i]).'">'. str_replace("\n",'<br>',stripslashes((trim($v)))) ."</a>&nbsp;</TD>\n";
						}
						else{
							$s .= "	<TD align=center>". str_replace("\n",'<br>',stripslashes((trim($v)))) ."&nbsp;</TD>\n";
						}
					}
				  
				}
			} // for
			
			//--     
			
			if( $fieldsExtra ){
				reset($fieldsExtra);
				while( list( $name, $link ) = each( $fieldsExtra ) ){
					$s .= '	<TD align=center><a href="'.str_replace('{$'.$fieldKey.'}', $rs->fields[$fieldKey], $link).'">'.$name."</a>&nbsp;</TD>\n";
				}
			}
			$s .= "</TR>\n\n";
			  
			$rows += 1;
			if ($rows >= $gSQLMaxRows) {
				$rows = "<p>Truncated at $gSQLMaxRows</p>";
				break;
			} // switch

			$rs->MoveNext();
		
		// additional EOF check to prevent a widow header
			if (!$rs->EOF && $rows % $gSQLBlockRows == 0) {
		
			//if (connection_aborted()) break;// not needed as PHP aborts script, unlike ASP
				print $s . "</TABLE>\n\n";
				$s = $hdr;
			}
		} // while

		print $s."</TABLE>\n\n";

	}

		if ($docnt) print "<H2>".$rows." Rows</H2>";
	
	return $rows;
 }
 
// pass in 2 dimensional array
function arr2html(&$arr,$ztabhtml='',$zheaderarray='')
{
	if (!$ztabhtml) $ztabhtml = 'BORDER=1';
	
	$s = "<TABLE $ztabhtml>";//';print_r($arr);

	if ($zheaderarray) {
		$s .= '<TR>';
		for ($i=0; $i<sizeof($zheaderarray); $i++) {
			$s .= "	<TH>{$zheaderarray[$i]}</TH>\n";
		}
		$s .= "\n</TR>";
	}
	
	for ($i=0; $i<sizeof($arr); $i++) {
		$s .= '<TR>';
		$a = &$arr[$i];
		if (is_array($a)) 
			for ($j=0; $j<sizeof($a); $j++) {
				$val = $a[$j];
				if (empty($val)) $val = '&nbsp;';
				$s .= "	<TD>$val</TD>\n";
			}
		else if ($a) {
			$s .=  '	<TD>'.$a."</TD>\n";
		} else $s .= "	<TD>&nbsp;</TD>\n";
		$s .= "\n</TR>\n";
	}
	$s .= '</TABLE>';
	print $s;
}


